package AA;

public class NewAtomicActionControl extends AtomicActionControl
                                           implements FourWayAtomicAction
{

  public NewAtomicActionControl()
  {
    Control = new RevisedController();
  }

  class RevisedController extends Controller 
  {
    private boolean fourthHere;

    RevisedController() {
      super();
      fourthHere = false;
      numberOfParticipants = 4;
      toExit = numberOfParticipants;
    }

    synchronized void fourth() throws InterruptedException
    {
      while(fourthHere) wait();
      fourthHere = true;
    }


    synchronized void finished() throws InterruptedException
    {
      super.finished();
      if(allDone == 0) {
        fourthHere = false;
        notifyAll();
        System.out.println(" reseeting flags 2");
      }
    }
  }

  public void role4() 
  {
    System.out.println(" role4 running ");
    boolean done = false;
    while(!done) {
      try {
        ((RevisedController)Control).fourth();
        done = true;
      } catch (InterruptedException e) {
        // ignore
      }
    } 

    System.out.println(" role4 ACTION ");
    try {
      Thread.sleep(500);
    } catch (InterruptedException x)  { };
    System.out.println(" role4  after sleep ");
    // .... perform action

    done = false;   
    while(!done) {
      try {
        Control.finished();
        done = true;
      } catch (InterruptedException e) {
        // ignore
      }
    }  
    System.out.println(" role 4 finishing ");
  }

}
